open Utils
open Format

type t =
  | Main_not_found
  | Main_wrong_kind
  | No_main_specified
  | Unbound_symbol of ident
  | Already_bound_symbol of ident
  | Unknown_library of ident
  | Wrong_number of ident
  | AlgebraicLoop of string * (formatter -> unit)
  | LoadError of string

exception Error of Location.t * t

val pp_algebraic_loops: formatter -> string -> (formatter -> unit) -> unit
val return_code : t -> int
val pp : formatter -> t -> unit
val pp_error : Location.t -> (formatter -> unit) -> unit
val pp_warning : Location.t -> (formatter -> unit) -> unit
